FROM python:3 as base

ENV PYTHONFAULTHANDLER=1 \
    PYTHONHASHSEED=random \
    PYTHONUNBUFFERED=1

WORKDIR /app

FROM base as builder

ENV PIP_DEFAULT_TIMEOUT=100 \
    PIP_DISABLE_PIP_VERSION_CHECK=1 \
    PIP_NO_CACHE_DIR=1 \
    POETRY_CACHE_DIR='/var/cache/pypoetry' \
    POETRY_VIRTUALENVS_CREATE=false \
    POETRY_VERSION=1.1.6

RUN pip install "poetry==$POETRY_VERSION"
RUN python -m venv /venv
RUN /venv/bin/pip install gunicorn

COPY pyproject.toml poetry.lock ./
RUN poetry export -f requirements.txt | /venv/bin/pip install -r /dev/stdin

COPY . .
RUN poetry build && /venv/bin/pip install dist/*.whl

FROM base as final

EXPOSE 80
COPY --from=builder /venv /venv
COPY --from=builder /app /app
COPY docker-entrypoint.sh ./
CMD ["./docker-entrypoint.sh"]
